###### Code à exécuter une fois pour toute
from random import randint
from random import random
import matplotlib.pyplot as plt
import numpy as np

x=np.linspace(0,99,100)
y=np.linspace(0,100,100)

plt.ion()

fig=plt.figure()
ax=fig.add_subplot(111)
line1, =ax.plot(x,y,'b.')

def trace(l):
    n=len(l)
    if len(line1.get_xdata())!=n:
        line1.set_xdata(np.linspace(0,n-1,n))
        ax.set_xbound(0,n-1)
        ax.set_ybound(0,max(l))
    line1.set_ydata(np.array(l))
    fig.canvas.draw()
    fig.pause(.01)
    
####### Exemple de génération d'une liste aléatoire de 30 réels entre 1 et 100

l=[random()*100 for _ in range(30)]

####### Tri à bulles

def esttrie(l):
    for k in range(len(l)-1):
        if l[k] > l[k+1]:
            return False
    return True
    
def tribulle(l):
    while not esttrie(l):
        for k in range(len(l)-1):
            if l[k] > l[k+1]:
                (l[k], l[k+1]) = (l[k+1], l[k])
    
l=[random()*100 for _ in range(30)]
print(l)
tribulle(l)
print(l)

def tribulle(l):
    while not esttrie(l):
        for k in range(len(l)-1):
            if l[k] > l[k+1]:
                (l[k], l[k+1]) = (l[k+1], l[k])
                trace(l)

####### Tri par sélection

def maximum(l,i):
    m = 0
    for k in range(i):
        if l[m] < l[k]:
            m = k
    return m
    
def triselection(l):
    n = len(l)
    for k in range(n):
        m = maximum(l, n-k)
        (l[m], l[n-1-k]) = (l[n-1-k], l[m])
        trace(l)
        
l=[random()*100 for _ in range(30)]
print(l)
triselection(l)
print(l)

####### Tri par insertion

def triinsertion(l):
    n = len(l)
    for i in range(1,n):
        k = i
        while l[k] < l[k-1] and k > 0:
            (l[k], l[k-1]) = (l[k-1], l[k])
            k = k-1
            trace(l)
    
l=[random()*100 for _ in range(30)]
print(l)
triinsertion(l)
print(l)

####### Tri fusion

def separe(l):
    n = len(l)
    return (l[:n//2], l[n//2:])
    
def fusionne(l1, l2): 
    (i1, i2) = (0, 0)
    r = []
    while i1 < len(l1) or i2 < len(l2):
        if i2 == len(l2) or (i1 < len(l1) and l1[i1] < l2[i2]):
            r.append(l1[i1])
            i1 = i1 + 1
        else:
            r.append(l2[i2])
            i2 = i2 + 1
    return r
    
def trifusion(l):
    if len(l) > 1:
        (l1, l2) = separe(l)
        return fusionne(trifusion(l1), trifusion(l2))
    return l
    
l=[random()*100 for _ in range(30)]
print(l)
trifusion(l)
print(l)
