from PIL.Image import *
from math import *

##### Débruitage

def filtremoyen(im):
    """débruite une image à l'aide d'un filtre moyen. Une nouvelle image est renvoyée"""
    w=im.width
    h=im.height
    r=new("L",(im.width,im.height),"black")
    for i in range(1,w-1):
        for j in range(1,h-1):
            s=0
            for x in range(-1,2):
                for y in range(-1,2):
                    s+=Image.getpixel(im,(i+x,j+y))
            Image.putpixel(r, (i,j),round(s/9))
    return r


def filtremedian(im):
    """débruite une image à l'aide d'un filtre médian. Une nouvelle image est renvoyée"""
    w=im.width
    h=im.height
    r=new("L",(im.width,im.height),"black")
    for i in range(1,w-1):
        for j in range(1,h-1):
            s=[]
            for x in range(-1,2):
                for y in range(-1,2):
                    s+=[Image.getpixel(im,(i+x,j+y))]
            s.sort()
            Image.putpixel(r, (i,j),s[4])
    return r

im = open( '/home/utilisateur/AP/stagePython/formation_python_partie_2/oiseaubruite.jpg' )

print(im.mode)

im.show()
imfiltree = filtremoyen(filtremoyen(im))
# imfiltree = filtremedian(im)
imfiltree.show()


##### Interpolation linéaire

def linear(im,x,y):
    """interpolation linéaire - renvoie une évaluation de «im(x,y)», où x et y ne sont pas nécessairement entiers"""
    xf=floor(x)
    yf=floor(y)
    lx=1-(x-xf)
    ly=1-(y-yf)
    return lx*ly*Image.getpixel(im, (xf, yf))+(1-lx)*ly*Image.getpixel(im, (xf+1, yf))+lx*(1-ly)*Image.getpixel(im, (xf, yf+1))+(1-lx)*(1-ly)*Image.getpixel(im, (xf+1, yf+1))

##### Rotation

def rotationnaif(im,theta):
    """rotation naïve (utilisation du plus proche pixel voisin)"""
    theta=-theta
    w=im.width
    h=im.height
    cx=w/2
    cy=h/2
    r=new("L",(im.width,im.height),"black")
    for i in range(0,w):
        for j in range(0,h):
            nx=round(cos(theta)*(i-cx)+sin(theta)*(j-cy)+cx)
            ny=round(-sin(theta)*(i-cx)+cos(theta)*(j-cy)+cy)
            if nx>=0 and nx<w and ny>=0 and ny<h:
                val=Image.getpixel(im,(nx,ny))
                Image.putpixel(r,(i,j),val)
    return r

im = open('.../bench.jpg')
im.show()
rot=rotationnaif(im,1)
rot.show()

def rotationinterpol(im,theta):
    """rotation utilisant l'interpolation linéaire"""
    theta=-theta
    w=im.width
    h=im.height
    cx=w/2
    cy=h/2
    r=new("L",(im.width,im.height),"black")
    for i in range(0,w):
        for j in range(0,h):
            nx=cos(theta)*(i-cx)+sin(theta)*(j-cy)+cx
            ny=-sin(theta)*(i-cx)+cos(theta)*(j-cy)+cy
            if nx>=0 and nx<w-1 and ny>=0 and ny<h-1:
                val=round(linear(im,nx,ny))
                Image.putpixel(r,(i,j),val)
    return r

rotlin=rotationinterpol(im,1)
rotlin.show()



