import matplotlib

import numpy
import matplotlib.pylab as plt
from copy import copy, deepcopy
from random import randint
from random import random
from matplotlib import animation
import time
g=[]

def configuration_initiale(n,p):
    """crée un tableau de tableaux représentant une grille de taille nXn"""
    m=[[0 for x in range(n)] for x in range(n)]
    for i in range(n):
        for j in range(n):
            if random()<p:
                m[i][j]=1
    return m

def nbvoisins(g,i,j):        
    s=0
    n=len(g)
    for k in range(-1,2):
        for l in range(-1,2):
            if k!=0 or l!=0:
                s=s+g[(i+k) % n][(j+l) % n]
    return s
    
    
def configuration_suivante(g):
    n=len(g)
    r=[[0 for x in range(n)] for x in range(n)]
    for i in range(n):
        for j in range(n):
            if g[i][j]==1 and nbvoisins(g,i,j) in [2,3]:
                r[i][j]=1  
            if g[i][j]==0 and nbvoisins(g,i,j) == 3:
                r[i][j]=1    
    return r
    



def jeudelavie(n,p):
    """simule et affiche les étapes sucessives d'un jeu de la vie de taille nXn. p est la probabilité qu'une case donnée soit occupée au départ"""
    global g
    #fonctions d'initialisation de la fenêtre graphique
    fig = plt.figure()

    #initialisation de la configuration initiale
    g=configuration_initiale(n,p)


    im=plt.imshow(g, vmin=0, vmax=1, interpolation='nearest', cmap=plt.cm.Greys, animated=True)


    def animate(i):
        global g
        g2=configuration_suivante(g)
        im.set_array(g2)
        g=g2
        return im,

    anim = animation.FuncAnimation(fig, animate, interval=100, blit=False)
    plt.show()
            
jeudelavie(10,.5)

